/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.veranstaltung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="VERANSTALTUNG.UK",
     query="SELECT o FROM Veranstaltung o WHERE "

                         + "o"
                +".externeId"
              +" = ?1"

             +" AND "         + "o"
                +".gebiet"
                +".nummer"
              +" = ?2"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?5"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?6"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?7"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?8"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?9"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".nummer"
              +" = ?10"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".wahldatum"
              +" = ?11"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?12"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?13"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?14"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?15"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?16"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?17"

             +" AND "         + "o"
                +".wahltermin"
                +".nummer"
              +" = ?18"

             +" AND "         + "o"
                +".wahltermin"
                +".wahldatum"
              +" = ?19"

             +" AND "         + "o"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?20"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="VERANSTALTUNG.Gebiet",
     query="SELECT o FROM Veranstaltung o WHERE o.gebiet=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="VERANSTALTUNG.UkNurWahl",
     query="SELECT o FROM Veranstaltung o WHERE o.externeId = ?1 AND o.gebiet.nummer = ?2 AND o.gebiet.gebietsart.name = ?3 AND o.gebiet.wahl.wahlart.name = ?4 AND o.gebiet.wahl.wahltermin.wahldatum = ?5 AND o.wahl.wahlart.name = ?4 AND o.wahl.wahltermin.wahldatum = ?5",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="VERANSTALTUNG.UkNurWahltermin",
     query="SELECT o FROM Veranstaltung o WHERE o.externeId = ?1 AND o.gebiet.nummer = ?2 AND o.gebiet.gebietsart.name = ?3 AND o.gebiet.wahltermin.wahldatum = ?4 AND o.wahltermin.wahldatum = ?4",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="VERANSTALTUNG.WahlOrderByBeginn",
     query="SELECT o FROM Veranstaltung o WHERE o.wahl = ?1 ORDER BY o.beginn",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="VERANSTALTUNG.WahlUndGebiet",
     query="SELECT o FROM Veranstaltung o WHERE o.wahl=?1 AND o.gebiet=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="VERANSTALTUNG.WahlterminOrderByBeginn",
     query="SELECT o FROM Veranstaltung o WHERE o.wahltermin = ?1 ORDER BY o.beginn",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="VERANSTALTUNG.WahlterminUndGebiet",
     query="SELECT o FROM Veranstaltung o WHERE o.wahltermin=?1 AND o.gebiet=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "VERANSTALTUNG")
// @javax.persistence.IdClass(VeranstaltungPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Veranstaltung
extends AbstractVeranstaltung
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Veranstaltung() {
    super();
  }
    public Veranstaltung(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Veranstaltung(Veranstaltung original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "veranstaltung_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Veranstaltung")
    @javax.persistence.TableGenerator(name = "Veranstaltung", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Veranstaltung", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient VeranstaltungPK pkCache;

  @Override
  public VeranstaltungPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new VeranstaltungPK(getId());
    }

    return pkCache;
  }

  public static <E extends Veranstaltung> java.util.Map<VeranstaltungPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<VeranstaltungPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Veranstaltung> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedBeginn = false;
          hasChangedBemerkung = false;
          hasChangedBezeichnung = false;
          hasChangedEnde = false;
          hasChangedExterneId = false;
          hasChangedRaumBezeichnung = false;
          hasChangedSchulungArt = false;
          hasChangedTeilnehmerAnzahlMax = false;
          hasChangedVeranstaltungArt = false;
          hasChangedVeranstaltungOrt = false;
          hasChangedVeranstaltungStatus = false;
  
      hasChangedAnschrift = false;
        hasChangedAnsprechpartner = false;
        hasChangedCustomDataStorage = false;
        hasChangedGebiet = false;
          hasChangedWahltermin = false;
        hasChangedWahl = false;
  

          hasChangedTeilnahmesByVeranstaltung = false;
                hasChangedVeranstaltungsByVerknuepfteVeranstaltung = false;
      
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "BEGINN", nullable = VeranstaltungConstants.BEGINN_NULLABLE, precision=VeranstaltungConstants.BEGINN_PRECISION)
    
  protected java.util.Date beginn =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBeginn = false;

  public boolean hasChangedBeginn(){
    return hasChangedBeginn;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBeginn = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenBeginn;
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.BEGINN
   */
    @Override   public  java.util.Date getBeginn() {
              if (beginn == null){
            return null;
          } else {
                          return beginn;
          }
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.BEGINN
   *
   * @param beginn
   */
  @Override   public void setBeginn( java.util.Date beginn) {

       resetTkCache();
                  java.util.Date beginnInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(beginn);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.beginn
      , beginnInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBeginn |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("beginn");
      }


             if (!isSeitLadenVeraendertBeginn) {
          isSeitLadenVeraendertBeginn = thisAttributChanged;
         if (isSeitLadenVeraendertBeginn){
           wertNachLadenBeginn=this.beginn;
         }
       }
      

       this.beginn = beginnInternal;

         }

        
  @javax.persistence.Column(name = "BEMERKUNG", nullable = VeranstaltungConstants.BEMERKUNG_NULLABLE, length=VeranstaltungConstants.BEMERKUNG_MAX_LENGTH)
        
  protected java.lang.String bemerkung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBemerkung = false;

  public boolean hasChangedBemerkung(){
    return hasChangedBemerkung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBemerkung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBemerkung;
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.BEMERKUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBemerkung() {
        return bemerkung;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.BEMERKUNG
   *
   * @param bemerkung
   */
  @Override   public void setBemerkung(@javax.annotation.Nullable  java.lang.String bemerkung) {

       resetTkCache();
                  
                          java.lang.String bemerkungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bemerkung, VeranstaltungConstants.BEMERKUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bemerkung
      , bemerkungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBemerkung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bemerkung");
      }


             if (!isSeitLadenVeraendertBemerkung) {
          isSeitLadenVeraendertBemerkung = thisAttributChanged;
         if (isSeitLadenVeraendertBemerkung){
           wertNachLadenBemerkung=this.bemerkung;
         }
       }
      

       this.bemerkung = bemerkungInternal;

         }

        
      @javax.persistence.Column(name = "BEZEICHNUNG", nullable = VeranstaltungConstants.BEZEICHNUNG_NULLABLE, length=VeranstaltungConstants.BEZEICHNUNG_MAX_LENGTH)
        
  protected java.lang.String bezeichnung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBezeichnung = false;

  public boolean hasChangedBezeichnung(){
    return hasChangedBezeichnung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBezeichnung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBezeichnung;
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.BEZEICHNUNG
   */
    @Override   public  java.lang.String getBezeichnung() {
        return bezeichnung;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.BEZEICHNUNG
   *
   * @param bezeichnung
   */
  @Override   public void setBezeichnung( java.lang.String bezeichnung) {

       resetTkCache();
                  
                          java.lang.String bezeichnungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bezeichnung, VeranstaltungConstants.BEZEICHNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bezeichnung
      , bezeichnungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBezeichnung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bezeichnung");
      }


             if (!isSeitLadenVeraendertBezeichnung) {
          isSeitLadenVeraendertBezeichnung = thisAttributChanged;
         if (isSeitLadenVeraendertBezeichnung){
           wertNachLadenBezeichnung=this.bezeichnung;
         }
       }
      

       this.bezeichnung = bezeichnungInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ENDE", nullable = VeranstaltungConstants.ENDE_NULLABLE, precision=VeranstaltungConstants.ENDE_PRECISION)
    
  protected java.util.Date ende =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEnde = false;

  public boolean hasChangedEnde(){
    return hasChangedEnde;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertEnde = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenEnde;
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.ENDE
   */
    @Override   public  java.util.Date getEnde() {
              if (ende == null){
            return null;
          } else {
                          return ende;
          }
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.ENDE
   *
   * @param ende
   */
  @Override   public void setEnde( java.util.Date ende) {

       resetTkCache();
                  java.util.Date endeInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(ende);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ende
      , endeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEnde |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ende");
      }


             if (!isSeitLadenVeraendertEnde) {
          isSeitLadenVeraendertEnde = thisAttributChanged;
         if (isSeitLadenVeraendertEnde){
           wertNachLadenEnde=this.ende;
         }
       }
      

       this.ende = endeInternal;

         }

        
  @javax.persistence.Column(name = "EXTERNE_ID", nullable = VeranstaltungConstants.EXTERNE_ID_NULLABLE, length=VeranstaltungConstants.EXTERNE_ID_MAX_LENGTH)
        
  protected java.lang.String externeId =  null;

  @javax.persistence.Transient
  protected boolean hasChangedExterneId = false;

  public boolean hasChangedExterneId(){
    return hasChangedExterneId;
  }
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.EXTERNE_ID
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getExterneId() {
        return externeId;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.EXTERNE_ID
   *
   * @param externeId
   */
  @Override   public void setExterneId(@javax.annotation.Nullable  java.lang.String externeId) {

       resetTkCache();
                  
                          java.lang.String externeIdInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(externeId, VeranstaltungConstants.EXTERNE_ID_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.externeId
      , externeIdInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedExterneId |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("externeId");
      }


      

       this.externeId = externeIdInternal;

         }

        
  @javax.persistence.Column(name = "RAUM_BEZEICHNUNG", nullable = VeranstaltungConstants.RAUM_BEZEICHNUNG_NULLABLE, length=VeranstaltungConstants.RAUM_BEZEICHNUNG_MAX_LENGTH)
        
  protected java.lang.String raumBezeichnung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedRaumBezeichnung = false;

  public boolean hasChangedRaumBezeichnung(){
    return hasChangedRaumBezeichnung;
  }
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.RAUM_BEZEICHNUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getRaumBezeichnung() {
        return raumBezeichnung;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.RAUM_BEZEICHNUNG
   *
   * @param raumBezeichnung
   */
  @Override   public void setRaumBezeichnung(@javax.annotation.Nullable  java.lang.String raumBezeichnung) {

       resetTkCache();
                  
                          java.lang.String raumBezeichnungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(raumBezeichnung, VeranstaltungConstants.RAUM_BEZEICHNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.raumBezeichnung
      , raumBezeichnungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedRaumBezeichnung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("raumBezeichnung");
      }


      

       this.raumBezeichnung = raumBezeichnungInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
  @javax.persistence.Column(name = "SCHULUNG_ART", nullable = VeranstaltungConstants.SCHULUNG_ART_NULLABLE)
    
  protected de.ivu.elect.business.veranstaltung.entity.SchulungArt schulungArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSchulungArt = false;

  public boolean hasChangedSchulungArt(){
    return hasChangedSchulungArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSchulungArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.veranstaltung.entity.SchulungArt wertNachLadenSchulungArt;
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.SCHULUNG_ART
   */
  @javax.annotation.Nullable   @Override   public  de.ivu.elect.business.veranstaltung.entity.SchulungArt getSchulungArt() {
        return schulungArt;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.SCHULUNG_ART
   *
   * @param schulungArt
   */
  @Override   public void setSchulungArt(@javax.annotation.Nullable  de.ivu.elect.business.veranstaltung.entity.SchulungArt schulungArt) {

       resetTkCache();
                  de.ivu.elect.business.veranstaltung.entity.SchulungArt schulungArtInternal = schulungArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.schulungArt
      , schulungArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSchulungArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("schulungArt");
      }


             if (!isSeitLadenVeraendertSchulungArt) {
          isSeitLadenVeraendertSchulungArt = thisAttributChanged;
         if (isSeitLadenVeraendertSchulungArt){
           wertNachLadenSchulungArt=this.schulungArt;
         }
       }
      

       this.schulungArt = schulungArtInternal;

         }

        
  @javax.persistence.Column(name = "TEILNEHMER_ANZAHL_MAX", nullable = VeranstaltungConstants.TEILNEHMER_ANZAHL_MAX_NULLABLE, precision=VeranstaltungConstants.TEILNEHMER_ANZAHL_MAX_PRECISION, scale=VeranstaltungConstants.TEILNEHMER_ANZAHL_MAX_SCALE)
            
  protected java.lang.Long teilnehmerAnzahlMax =  null;

  @javax.persistence.Transient
  protected boolean hasChangedTeilnehmerAnzahlMax = false;

  public boolean hasChangedTeilnehmerAnzahlMax(){
    return hasChangedTeilnehmerAnzahlMax;
  }
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.TEILNEHMER_ANZAHL_MAX
   */
  @javax.annotation.Nullable   @Override   public  java.lang.Long getTeilnehmerAnzahlMax() {
        return teilnehmerAnzahlMax;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.TEILNEHMER_ANZAHL_MAX
   *
   * @param teilnehmerAnzahlMax
   */
  @Override   public void setTeilnehmerAnzahlMax(@javax.annotation.Nullable  java.lang.Long teilnehmerAnzahlMax) {

       resetTkCache();
                  java.lang.Long teilnehmerAnzahlMaxInternal = teilnehmerAnzahlMax;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.teilnehmerAnzahlMax
      , teilnehmerAnzahlMaxInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedTeilnehmerAnzahlMax |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("teilnehmerAnzahlMax");
      }


      

       this.teilnehmerAnzahlMax = teilnehmerAnzahlMaxInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "VERANSTALTUNG_ART", nullable = VeranstaltungConstants.VERANSTALTUNG_ART_NULLABLE)
    
  protected de.ivu.elect.business.veranstaltung.entity.VeranstaltungArt veranstaltungArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedVeranstaltungArt = false;

  public boolean hasChangedVeranstaltungArt(){
    return hasChangedVeranstaltungArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertVeranstaltungArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.veranstaltung.entity.VeranstaltungArt wertNachLadenVeranstaltungArt;
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.VERANSTALTUNG_ART
   */
    @Override   public  de.ivu.elect.business.veranstaltung.entity.VeranstaltungArt getVeranstaltungArt() {
        return veranstaltungArt;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.VERANSTALTUNG_ART
   *
   * @param veranstaltungArt
   */
  @Override   public void setVeranstaltungArt( de.ivu.elect.business.veranstaltung.entity.VeranstaltungArt veranstaltungArt) {

       resetTkCache();
                  de.ivu.elect.business.veranstaltung.entity.VeranstaltungArt veranstaltungArtInternal = veranstaltungArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.veranstaltungArt
      , veranstaltungArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedVeranstaltungArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("veranstaltungArt");
      }


             if (!isSeitLadenVeraendertVeranstaltungArt) {
          isSeitLadenVeraendertVeranstaltungArt = thisAttributChanged;
         if (isSeitLadenVeraendertVeranstaltungArt){
           wertNachLadenVeranstaltungArt=this.veranstaltungArt;
         }
       }
      

       this.veranstaltungArt = veranstaltungArtInternal;

         }

        
  @javax.persistence.Column(name = "VERANSTALTUNG_ORT", nullable = VeranstaltungConstants.VERANSTALTUNG_ORT_NULLABLE, length=VeranstaltungConstants.VERANSTALTUNG_ORT_MAX_LENGTH)
        
  protected java.lang.String veranstaltungOrt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedVeranstaltungOrt = false;

  public boolean hasChangedVeranstaltungOrt(){
    return hasChangedVeranstaltungOrt;
  }
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.VERANSTALTUNG_ORT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getVeranstaltungOrt() {
        return veranstaltungOrt;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.VERANSTALTUNG_ORT
   *
   * @param veranstaltungOrt
   */
  @Override   public void setVeranstaltungOrt(@javax.annotation.Nullable  java.lang.String veranstaltungOrt) {

       resetTkCache();
                  
                          java.lang.String veranstaltungOrtInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(veranstaltungOrt, VeranstaltungConstants.VERANSTALTUNG_ORT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.veranstaltungOrt
      , veranstaltungOrtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedVeranstaltungOrt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("veranstaltungOrt");
      }


      

       this.veranstaltungOrt = veranstaltungOrtInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "VERANSTALTUNG_STATUS", nullable = VeranstaltungConstants.VERANSTALTUNG_STATUS_NULLABLE)
    
  protected de.ivu.elect.business.veranstaltung.entity.VeranstaltungStatus veranstaltungStatus =  de.ivu.elect.business.veranstaltung.entity.VeranstaltungStatus.ERSTELLT;

  @javax.persistence.Transient
  protected boolean hasChangedVeranstaltungStatus = false;

  public boolean hasChangedVeranstaltungStatus(){
    return hasChangedVeranstaltungStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertVeranstaltungStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.veranstaltung.entity.VeranstaltungStatus wertNachLadenVeranstaltungStatus;
  
  /**
   * 
   *
   * getter for VERANSTALTUNG.VERANSTALTUNG_STATUS
   */
    @Override   public  de.ivu.elect.business.veranstaltung.entity.VeranstaltungStatus getVeranstaltungStatus() {
        return veranstaltungStatus;
      }

  /**
   * 
   *
   * setter for VERANSTALTUNG.VERANSTALTUNG_STATUS
   *
   * @param veranstaltungStatus
   */
  @Override   public void setVeranstaltungStatus( de.ivu.elect.business.veranstaltung.entity.VeranstaltungStatus veranstaltungStatus) {

       resetTkCache();
                  de.ivu.elect.business.veranstaltung.entity.VeranstaltungStatus veranstaltungStatusInternal = veranstaltungStatus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.veranstaltungStatus
      , veranstaltungStatusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedVeranstaltungStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("veranstaltungStatus");
      }


             if (!isSeitLadenVeraendertVeranstaltungStatus) {
          isSeitLadenVeraendertVeranstaltungStatus = thisAttributChanged;
         if (isSeitLadenVeraendertVeranstaltungStatus){
           wertNachLadenVeranstaltungStatus=this.veranstaltungStatus;
         }
       }
      

       this.veranstaltungStatus = veranstaltungStatusInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Anschrift
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ANSCHRIFT_ID", referencedColumnName="ANSCHRIFT_ID"))
  protected de.ivu.elect.business.anschrift.entity.Anschrift anschrift;

  /**
   * 
   */
  @Override
  public void setAnschrift( de.ivu.elect.business.anschrift.entity.Anschrift anschrift){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anschrift
    , anschrift);

    attributeChanged |= thisAttributChanged;

    hasChangedAnschrift |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("anschrift");
    }

    this.anschrift = anschrift;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.anschrift.entity.Anschrift getAnschrift(){
    return this.anschrift;
  }

  @javax.persistence.Transient
  protected boolean hasChangedAnschrift = false;

  public boolean hasChangedAnschrift(){
    return hasChangedAnschrift;
  }

  /**
   * Beziehung (unidirektional) zu Ansprechpartner
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ANSPRECHPARTNER_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.person.entity.Personendaten ansprechpartner;

  /**
   * 
   */
  @Override
  public void setAnsprechpartner( de.ivu.elect.business.person.entity.Personendaten ansprechpartner){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ansprechpartner
    , ansprechpartner);

    attributeChanged |= thisAttributChanged;

    hasChangedAnsprechpartner |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("ansprechpartner");
    }

    this.ansprechpartner = ansprechpartner;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.person.entity.Personendaten getAnsprechpartner(){
    return this.ansprechpartner;
  }

  @javax.persistence.Transient
  protected boolean hasChangedAnsprechpartner = false;

  public boolean hasChangedAnsprechpartner(){
    return hasChangedAnsprechpartner;
  }

  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }

  /**
   * Beziehung (unidirektional) zu Gebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GEBIET_ID", referencedColumnName="GEBIET_ID"))
  protected de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet;

  /**
   * 
   */
  @Override
  public void setGebiet( de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gebiet
    , gebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedGebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gebiet");
    }

    this.gebiet = gebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gebietsbaum.entity.Gebiet getGebiet(){
    return this.gebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGebiet = false;

  public boolean hasChangedGebiet(){
    return hasChangedGebiet;
  }

  /**
   * Beziehung (unidirektional) zu Wahltermin
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin wahltermin;

  /**
   * 
   */
  @Override
  public void setWahltermin( de.ivu.elect.business.wahl.entity.Wahltermin wahltermin){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahltermin
    , wahltermin);

    attributeChanged |= thisAttributChanged;

    hasChangedWahltermin |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahltermin");
    }

    this.wahltermin = wahltermin;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getWahltermin(){
    return this.wahltermin;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahltermin = false;

  public boolean hasChangedWahltermin(){
    return hasChangedWahltermin;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
           de.ivu.elect.business.wahl.entity.Wahl alterWert = getWahl();
       preSetWahl(alterWert, wahl);
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
         postSetWahl(alterWert, wahl);
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */
  /**
   * Beziehung N:1 (bidirektional) zu VerknuepfteVeranstaltung
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "VERKNUEPFTE_VERANSTALTUNG_ID", referencedColumnName="VERANSTALTUNG_ID"))
  protected de.ivu.elect.business.veranstaltung.entity.Veranstaltung verknuepfteVeranstaltung;

  /**
   * 
   */
  @Override
  public void setVerknuepfteVeranstaltung(@javax.annotation.Nullable  de.ivu.elect.business.veranstaltung.entity.Veranstaltung verknuepfteVeranstaltung){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

    

        if (verknuepfteVeranstaltung == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.verknuepfteVeranstaltung != null){
            this.verknuepfteVeranstaltung.removeVeranstaltungByVerknuepfteVeranstaltung(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          verknuepfteVeranstaltung.addVeranstaltungByVerknuepfteVeranstaltung(this);
        }
        this.verknuepfteVeranstaltung = verknuepfteVeranstaltung;
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setVerknuepfteVeranstaltungOhneUpdateBeziehung(@javax.annotation.Nullable  de.ivu.elect.business.veranstaltung.entity.Veranstaltung verknuepfteVeranstaltung){
    resetTkCache();
        this.verknuepfteVeranstaltung = verknuepfteVeranstaltung;
    }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.veranstaltung.entity.Veranstaltung getVerknuepfteVeranstaltung(){
    return this.verknuepfteVeranstaltung;
  }


  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu TeilnahmesByVeranstaltung
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.veranstaltung.entity.Teilnahme.class, mappedBy="veranstaltung", fetch=javax.persistence.FetchType.LAZY )
// elect-deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.veranstaltung.entity.Teilnahme> teilnahmesByVeranstaltung;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.veranstaltung.entity.Teilnahme> getTeilnahmesByVeranstaltung(){
    if (teilnahmesByVeranstaltung == null){
      return  java.util.Collections.<de.ivu.elect.business.veranstaltung.entity.Teilnahme>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.veranstaltung.entity.Teilnahme>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.veranstaltung.entity.Teilnahme>unmodifiableSet(this.teilnahmesByVeranstaltung);
  }

  @javax.persistence.Transient
  private boolean hasChangedTeilnahmesByVeranstaltung = false;

  public boolean hasChangedTeilnahmesByVeranstaltung() {
    return hasChangedTeilnahmesByVeranstaltung;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.veranstaltung.entity.Teilnahme
   */
  @Override
  public void addTeilnahmeByVeranstaltung(de.ivu.elect.business.veranstaltung.entity.Teilnahme teilnahmeByVeranstaltung){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (teilnahmeByVeranstaltung != null){
          if (this.teilnahmesByVeranstaltung == null) {
            this.teilnahmesByVeranstaltung = new java.util.HashSet<>();
          }

          boolean isChanged = this.teilnahmesByVeranstaltung.add(teilnahmeByVeranstaltung);

          if(!hasChangedTeilnahmesByVeranstaltung) {
            hasChangedTeilnahmesByVeranstaltung =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          teilnahmeByVeranstaltung.setVeranstaltung(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.veranstaltung.entity.Teilnahme
   */
  @Override
  public void removeTeilnahmeByVeranstaltung(de.ivu.elect.business.veranstaltung.entity.Teilnahme teilnahmeByVeranstaltung){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (teilnahmeByVeranstaltung != null){
          if (this.teilnahmesByVeranstaltung != null) {
            boolean isChanged = this.teilnahmesByVeranstaltung.remove(teilnahmeByVeranstaltung);

            if(!hasChangedTeilnahmesByVeranstaltung) {
              hasChangedTeilnahmesByVeranstaltung =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          teilnahmeByVeranstaltung.setVeranstaltung(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.veranstaltung.entity.Teilnahme
  */
   @Override
   public void removeAllTeilnahmeByVeranstaltungs(){
     java.util.Set<de.ivu.elect.business.veranstaltung.entity.Teilnahme> toRemove = new java.util.HashSet<>(getTeilnahmesByVeranstaltung());

     for (   de.ivu.elect.business.veranstaltung.entity.Teilnahme entity:toRemove){
       removeTeilnahmeByVeranstaltung(entity);
     }
   }

  /**
   * Beziehung 1:N (bidirektional) zu VeranstaltungsByVerknuepfteVeranstaltung
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.veranstaltung.entity.Veranstaltung.class, mappedBy="verknuepfteVeranstaltung", fetch=javax.persistence.FetchType.LAZY )
// elect-deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.veranstaltung.entity.Veranstaltung> veranstaltungsByVerknuepfteVeranstaltung;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.veranstaltung.entity.Veranstaltung> getVeranstaltungsByVerknuepfteVeranstaltung(){
    if (veranstaltungsByVerknuepfteVeranstaltung == null){
      return  java.util.Collections.<de.ivu.elect.business.veranstaltung.entity.Veranstaltung>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.veranstaltung.entity.Veranstaltung>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.veranstaltung.entity.Veranstaltung>unmodifiableSet(this.veranstaltungsByVerknuepfteVeranstaltung);
  }

  @javax.persistence.Transient
  private boolean hasChangedVeranstaltungsByVerknuepfteVeranstaltung = false;

  public boolean hasChangedVeranstaltungsByVerknuepfteVeranstaltung() {
    return hasChangedVeranstaltungsByVerknuepfteVeranstaltung;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.veranstaltung.entity.Veranstaltung
   */
  @Override
  public void addVeranstaltungByVerknuepfteVeranstaltung(de.ivu.elect.business.veranstaltung.entity.Veranstaltung veranstaltungByVerknuepfteVeranstaltung){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (veranstaltungByVerknuepfteVeranstaltung != null){
          if (this.veranstaltungsByVerknuepfteVeranstaltung == null) {
            this.veranstaltungsByVerknuepfteVeranstaltung = new java.util.HashSet<>();
          }

          boolean isChanged = this.veranstaltungsByVerknuepfteVeranstaltung.add(veranstaltungByVerknuepfteVeranstaltung);

          if(!hasChangedVeranstaltungsByVerknuepfteVeranstaltung) {
            hasChangedVeranstaltungsByVerknuepfteVeranstaltung =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          veranstaltungByVerknuepfteVeranstaltung.setVerknuepfteVeranstaltung(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.veranstaltung.entity.Veranstaltung
   */
  @Override
  public void removeVeranstaltungByVerknuepfteVeranstaltung(de.ivu.elect.business.veranstaltung.entity.Veranstaltung veranstaltungByVerknuepfteVeranstaltung){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (veranstaltungByVerknuepfteVeranstaltung != null){
          if (this.veranstaltungsByVerknuepfteVeranstaltung != null) {
            boolean isChanged = this.veranstaltungsByVerknuepfteVeranstaltung.remove(veranstaltungByVerknuepfteVeranstaltung);

            if(!hasChangedVeranstaltungsByVerknuepfteVeranstaltung) {
              hasChangedVeranstaltungsByVerknuepfteVeranstaltung =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          veranstaltungByVerknuepfteVeranstaltung.setVerknuepfteVeranstaltung(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.veranstaltung.entity.Veranstaltung
  */
   @Override
   public void removeAllVeranstaltungByVerknuepfteVeranstaltungs(){
     java.util.Set<de.ivu.elect.business.veranstaltung.entity.Veranstaltung> toRemove = new java.util.HashSet<>(getVeranstaltungsByVerknuepfteVeranstaltung());

     for (   de.ivu.elect.business.veranstaltung.entity.Veranstaltung entity:toRemove){
       removeVeranstaltungByVerknuepfteVeranstaltung(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Veranstaltung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Veranstaltung other){
                             other.beginn = this.beginn;
                                other.bemerkung = this.bemerkung;
                                other.bezeichnung = this.bezeichnung;
                                other.ende = this.ende;
                                other.externeId = this.externeId;
                                other.raumBezeichnung = this.raumBezeichnung;
                                other.schulungArt = this.schulungArt;
                                other.teilnehmerAnzahlMax = this.teilnehmerAnzahlMax;
                                other.veranstaltungArt = this.veranstaltungArt;
                                other.veranstaltungOrt = this.veranstaltungOrt;
                                other.veranstaltungStatus = this.veranstaltungStatus;
           
  other.setAnschrift(this.getAnschrift());
  other.setAnsprechpartner(this.getAnsprechpartner());
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setGebiet(this.getGebiet());
  other.setVerknuepfteVeranstaltung(this.getVerknuepfteVeranstaltung());
  other.setWahltermin(this.getWahltermin());
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Veranstaltung.class)){
        copyEntityAttributesUsingSetter((Veranstaltung) other.castTo(Veranstaltung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Veranstaltung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Veranstaltung other){
               other.setBeginn(this.beginn);
                  other.setBemerkung(this.bemerkung);
                  other.setBezeichnung(this.bezeichnung);
                  other.setEnde(this.ende);
                  other.setExterneId(this.externeId);
                  other.setRaumBezeichnung(this.raumBezeichnung);
                  other.setSchulungArt(this.schulungArt);
                  other.setTeilnehmerAnzahlMax(this.teilnehmerAnzahlMax);
                  other.setVeranstaltungArt(this.veranstaltungArt);
                  other.setVeranstaltungOrt(this.veranstaltungOrt);
                  other.setVeranstaltungStatus(this.veranstaltungStatus);
           other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Veranstaltung other){
                       if (hasChangedBeginn) {
        other.setBeginn(this.beginn);
      }
                             if (hasChangedBemerkung) {
        other.setBemerkung(this.bemerkung);
      }
                             if (hasChangedBezeichnung) {
        other.setBezeichnung(this.bezeichnung);
      }
                             if (hasChangedEnde) {
        other.setEnde(this.ende);
      }
                             if (hasChangedExterneId) {
        other.setExterneId(this.externeId);
      }
                             if (hasChangedRaumBezeichnung) {
        other.setRaumBezeichnung(this.raumBezeichnung);
      }
                             if (hasChangedSchulungArt) {
        other.setSchulungArt(this.schulungArt);
      }
                             if (hasChangedTeilnehmerAnzahlMax) {
        other.setTeilnehmerAnzahlMax(this.teilnehmerAnzahlMax);
      }
                             if (hasChangedVeranstaltungArt) {
        other.setVeranstaltungArt(this.veranstaltungArt);
      }
                             if (hasChangedVeranstaltungOrt) {
        other.setVeranstaltungOrt(this.veranstaltungOrt);
      }
                             if (hasChangedVeranstaltungStatus) {
        other.setVeranstaltungStatus(this.veranstaltungStatus);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität Veranstaltung besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    @Override
    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    @Override
    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität Veranstaltung hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität Veranstaltung hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität Veranstaltung hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität Veranstaltung hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient VeranstaltungTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public VeranstaltungTK getVeranstaltungTK(){
    if (tkCache==null) {
    tkCache = new VeranstaltungTK(

getExterneId()
,   (getGebiet() == null) ? null : getGebiet().getGebietTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getVeranstaltungTK();
    }

  @Override
  public VeranstaltungUK getUk(){
    return getVeranstaltungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Veranstaltung.class;
  }

public VeranstaltungUK getVeranstaltungUK(){

   return  new VeranstaltungUK(

getExterneId()
,     getGebiet()==null?null:getGebiet().getGebietUK()
,     getWahl()==null?null:getWahl().getWahlUK()
,     getWahltermin()==null?null:getWahltermin().getWahlterminUK()


  );
}

  @javax.persistence.Transient
  private transient VeranstaltungProperties properties;

  public VeranstaltungProperties getProperties(){
    if (properties == null) {
      properties = new VeranstaltungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public VeranstaltungProperties getVeranstaltungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return VeranstaltungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(VeranstaltungConstants.MESSAGE_KEY_BEGINN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(VeranstaltungConstants.MESSAGE_KEY_BEGINN_EINZAHL);

        beginn =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(VeranstaltungConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(VeranstaltungConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL);

        bemerkung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(VeranstaltungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(VeranstaltungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL);

        bezeichnung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(VeranstaltungConstants.MESSAGE_KEY_ENDE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(VeranstaltungConstants.MESSAGE_KEY_ENDE_EINZAHL);

        ende =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                            
      if (werteVorher.containsKey(VeranstaltungConstants.MESSAGE_KEY_SCHULUNG_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(VeranstaltungConstants.MESSAGE_KEY_SCHULUNG_ART_EINZAHL);

        schulungArt =
     (de.ivu.elect.business.veranstaltung.entity.SchulungArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                    
      if (werteVorher.containsKey(VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_ART_EINZAHL);

        veranstaltungArt =
     (de.ivu.elect.business.veranstaltung.entity.VeranstaltungArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                    
      if (werteVorher.containsKey(VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_STATUS_EINZAHL);

        veranstaltungStatus =
     (de.ivu.elect.business.veranstaltung.entity.VeranstaltungStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBeginn) {
      result.put(VeranstaltungConstants.MESSAGE_KEY_BEGINN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenBeginn , beginn));
    }
                            if (isSeitLadenVeraendertBemerkung) {
      result.put(VeranstaltungConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBemerkung , bemerkung));
    }
                            if (isSeitLadenVeraendertBezeichnung) {
      result.put(VeranstaltungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBezeichnung , bezeichnung));
    }
                            if (isSeitLadenVeraendertEnde) {
      result.put(VeranstaltungConstants.MESSAGE_KEY_ENDE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenEnde , ende));
    }
                                                                    if (isSeitLadenVeraendertSchulungArt) {
      result.put(VeranstaltungConstants.MESSAGE_KEY_SCHULUNG_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenSchulungArt , schulungArt));
    }
                                                if (isSeitLadenVeraendertVeranstaltungArt) {
      result.put(VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenVeranstaltungArt , veranstaltungArt));
    }
                                                if (isSeitLadenVeraendertVeranstaltungStatus) {
      result.put(VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenVeranstaltungStatus , veranstaltungStatus));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBeginn = false;
      wertNachLadenBeginn = null;
                          isSeitLadenVeraendertBemerkung = false;
      wertNachLadenBemerkung = null;
                          isSeitLadenVeraendertBezeichnung = false;
      wertNachLadenBezeichnung = null;
                          isSeitLadenVeraendertEnde = false;
      wertNachLadenEnde = null;
                                                          isSeitLadenVeraendertSchulungArt = false;
      wertNachLadenSchulungArt = null;
                                          isSeitLadenVeraendertVeranstaltungArt = false;
      wertNachLadenVeranstaltungArt = null;
                                          isSeitLadenVeraendertVeranstaltungStatus = false;
      wertNachLadenVeranstaltungStatus = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    if (anschrift != null) {
          if (!result.contains(anschrift)) {
            de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode node = new de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode(VeranstaltungConstants.MESSAGE_KEY_ANSCHRIFT_ID_EINZAHL, anschrift);
            result.add(node);
            node.getChildren().addAll(anschrift.getFachlichAbhaengigeEntitaeten());
          }
        }
                    if (ansprechpartner != null) {
          if (!result.contains(ansprechpartner)) {
            de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode node = new de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode(VeranstaltungConstants.MESSAGE_KEY_ANSPRECHPARTNER_ID_EINZAHL, ansprechpartner);
            result.add(node);
            node.getChildren().addAll(ansprechpartner.getFachlichAbhaengigeEntitaeten());
          }
        }
                    if (customDataStorage != null) {
          if (!result.contains(customDataStorage)) {
            de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode node = new de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode(VeranstaltungConstants.MESSAGE_KEY_CUSTOM_DATA_STORAGE_ID_EINZAHL, customDataStorage);
            result.add(node);
            node.getChildren().addAll(customDataStorage.getFachlichAbhaengigeEntitaeten());
          }
        }
                                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "VERANSTALTUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Veranstaltung";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(beginn, this, VeranstaltungConstants.MESSAGE_KEY_BEGINN_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(VeranstaltungConstants.BEMERKUNG_MAX_LENGTH ,  bemerkung, this, VeranstaltungConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(bezeichnung, this, VeranstaltungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(VeranstaltungConstants.BEZEICHNUNG_MAX_LENGTH , 1 ,  bezeichnung, this, VeranstaltungConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ende, this, VeranstaltungConstants.MESSAGE_KEY_ENDE_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(VeranstaltungConstants.EXTERNE_ID_MAX_LENGTH ,  externeId, this, VeranstaltungConstants.MESSAGE_KEY_EXTERNE_ID_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(VeranstaltungConstants.RAUM_BEZEICHNUNG_MAX_LENGTH ,  raumBezeichnung, this, VeranstaltungConstants.MESSAGE_KEY_RAUM_BEZEICHNUNG_EINZAHL, validationResult);
                                                                                                                                                            de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(VeranstaltungConstants.TEILNEHMER_ANZAHL_MAX_MAX_VALUE, VeranstaltungConstants.TEILNEHMER_ANZAHL_MAX_MIN_VALUE, teilnehmerAnzahlMax, this, VeranstaltungConstants.MESSAGE_KEY_TEILNEHMER_ANZAHL_MAX_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(veranstaltungArt, this, VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_ART_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(VeranstaltungConstants.VERANSTALTUNG_ORT_MAX_LENGTH ,  veranstaltungOrt, this, VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_ORT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(veranstaltungStatus, this, VeranstaltungConstants.MESSAGE_KEY_VERANSTALTUNG_STATUS_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
